KParts::GenericFactory< T > Class Template Reference

`#include <genericfactory.h>`

Inherits KParts::GenericFactoryBase< T >.

## Public Member Functions

virtual KParts::Part * | createPartObject (QWidget *parentWidget, const char *widgetName, QObject *parent, const char *name, const char *className, const QStringList &args)

## Detailed Description

### template<class T>
class KParts::GenericFactory< T >

A template for a KParts::Factory implementation.

It implements the pure virtual createPartObject method by instantiating the template argument when requested through the className field. In addition it is a container for a part's KInstance object, by providing a static KInstance *instance() method.

The template argument has to inherit from KParts::Part and has to implement two methods: 1) There needs to be a public constructor with the following signature: MyPart( QWidget *parentWidget, const char *widgetName, QObject *parent, const char *name, const QStringList& args )

2) It needs to provide one static method to create a KAboutData object per request, holding information about the component's name, its authors, license, etc. The signature of that static method has to be KAboutData *createAboutData()

The template will take care of memory management of the KInstance and the KAboutData object, meaning ownership of what createAboutData returns is passed to the caller (this template) .

For advanced use you can also inherit from the template and re-implement additionally the virtual KInstance *createInstance() method, for example in case you want to extend the paths of your instance's KStandardDirs object.

If a KParts::ReadOnlyPart is requested through this factory and the template argument implements a KParts::ReadWritePart then setReadWrite( false ) will automatically be called in createPartObject.

Use the factory through the K_EXPORT_COMPONENT_FACTORY macro, like that:

typedef KParts::GenericFactory&lt;YourKPart&gt; YourKPartFactory;
K_EXPORT_COMPONENT_FACTORY( yourlibrary, YourKPartFactory )

yourlibrary is the library name that you compiled your KPart into.

Definition at line 95 of file genericfactory.h.

## Member Function Documentation

template<class T >

virtual KParts::Part* KParts::GenericFactory< T >::createPartObject | ( | QWidget * | parentWidget,
|  | const char * | widgetName,
|  | QObject * | parent,
|  | const char * | name,
|  | const char * | classname,
|  | const QStringList & | args
| ) |  |

inline virtual

Reimplement this method in your implementation to create the Part.

The QStringList can be used to pass additional arguments to the part. If the part needs additional arguments, it should take them as name="value" pairs. This is the way additional arguments will get passed to the part from eg. khtml. You can for example emebed the part into HTML by using the following code:

<object type="my_mimetype" data="url_to_my_data">
<param name="name1" value="value1">
<param name="name2" value="value2">
</object>

This could result in a call to

createPart( parentWidget, name, parentObject, parentName, "Kparts::Part",
QStringList("name1="value1"", "name2="value2") );

Returns
  the newly created part.

Implements KParts::Factory.

Definition at line 100 of file genericfactory.h.

The documentation for this class was generated from the following file:

- genericfactory.h

KDE Home | KDE Accessibility Home | Description of Access Keys